#!/bin/sh
# NOTE:
# This intercepts the Arduino IDE avr-objcopy command
# it requires that you modify the platforms.txt file down in
# {installdir}/hardware/arduino/avr
# as follows.
#
# change the "Create Hex" recipe to:
# recipe.objcopy.hex.pattern="{compiler.path}../../avr-objcopy-wrapper.sh" "{compiler.path}{compiler.elf2hex.cmd}" "{compiler.elf2hex.flags}" "{build.path}/{build.project_name}.elf" "{build.path}/{build.project_name}.hex"
#
# You must then name this script avr-objcopy-wripper.sh and put it into
# {installdir}/hardware/tools
#
# after that, the files will be built automatically every time the sketch
# is built.
#
# Note that anything output from this script will show up as "red" on IDE console
#
# 2014.02.21  bperrybap - original creation
#
# author:   Bill Perry  - bperrybap@opensource.billsworld.billandterrie.com
#
##############################################################################################


echo Start of objcopy wrapper ---------------------
elfname=$3
bname=`basename $elfname .elf`
buildpath=`dirname $elfname`
compilerpath=`dirname $1`

echo Creating Listing file $buildpath/$bname.lss
#echo "$compilerpath/avr-objdump -s -H $elfname > $buildpath/$bname.lss"
$compilerpath/avr-objdump -S -h $elfname > $buildpath/$bname.lss

echo Creating Symbol table file $buildpath/$bname.sym
#echo "$compilerpath/avr-nm -S $elfname >$buildpath/$bname.sym"
$compilerpath/avr-nm -S $elfname >$buildpath/$bname.sym

echo Creating hex file $elfname
#echo $*
# run the original command
$*

echo End of objcopy wrapper ---------------------
